
#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

/* Common Block Declarations */

struct {
    double r__[32]	/* was [16][2] */, deltr[32]	/* was [16][2] */;
    int ni;
} deltr_;

#define deltr_1 deltr_

int main(void)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, k, m;
    static double q;
    static int s;
    static double y[2], h0, xk, xn, yn[2], yt[2], rab[446];
    extern int de53d_c( );
    static double dely[2];
    static int imax, iniap0, iniapr;
    extern int ftreat_c();

    deltr_1.ni = 16;
    m = 2;
    q = .5;
    xn = 0.f;
    yn[0] = cos(q) + 1.;
    yn[1] = -sin(q) + 1.;
    xk = 1.;
    h0 = .5;
    yt[0] = cos(q * (xk * 2. - 1.)) + 1.;
    yt[1] = sin(q * (xk * 2. - 1.)) + 1.;
    k = 11;
    imax = 13;
    for (iniap0 = 1; iniap0 <= 2; ++iniap0) {
	iniapr = iniap0;
	h__ = h0;

	de53d_c((U_fp)f_c, (U_fp)ftreat_c, &m, &xn, yn, &xk, &k, &iniapr, &imax,
		&h__, y, rab);
	dely[0] = yt[0] - y[0];
	dely[1] = yt[1] - y[1];

    printf("\n -------------------------------------------------------");
    printf("\n h0=%21.14e k=%3i iniapr= %1i imax=%3i\n",h0,k,iniapr,imax);
    printf("\n y[0]= %21.14e y[1]=%21.14e\n",y[0],y[1]);
    printf("\n yt[0]=%21.14e yt[1]= %21.14e\n",yt[0],yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e \n", dely[0], dely[1]);
    printf("\n -------------------------------------------------------");

	for (s = 1; s <= 2; ++s) {
        printf("\n\n              Phase motion  for %3i segment\n", s);
	printf("\n              distance                error\n");

	    i__1 = deltr_1.ni;
	    for (j = 1; j <= i__1; ++j) {
  printf("\n %3i %23.14e %23.14e", j,deltr_1.r__[j + (s << 4) - 17],deltr_1.deltr[j + (s << 4) - 17]);
	    }
/* L10: */
	}
    printf("\n\n ******************************************************\n");
/* L42: */
    }
    return 0;
} /* main */
/*.......................................................................*/

 int f_c(double *x, double *y, double *z__, int *m)
{
    /* Builtin functions */
    double cos(double), exp(double), sin(double);

    /* Local variables */
    static double q, r__;

    /* Parameter adjustments */
    --z__;
    --y;

    /* Function Body */
    q = .5;
    r__ = *x * 2. - 1.;
    z__[1] = q * -2. * (y[2] - 1.) + (1. - exp(1. - y[1] + cos(q * r__))) / (*
	    x + 1.);
    z__[2] = q * 2. * (y[1] - 1.) + (1. - exp(1. - y[2] + sin(q * r__))) / (*
	    x + 1.);
    return 0;
} /* f_c */

/*.............................................................................*/

 int ftreat_c(int *s, double *xi, double *xe, double *y,
              double *ay, double *ady, int *m, int *kp1, int *kp2)
{
    /* System generated locals */
    int ay_dim1, ay_offset, ady_dim1, ady_offset, i__1;
    double d__1, d__2;

    /* Builtin functions */
    double sqrt(double);

    /* Local variables */
    static int j;
    static double x, bk[4]	/* was [2][2] */, hi, yi[2];
    extern int de70dc_c( );

    /* Parameter adjustments */
    ady_dim1 = *m;
    ady_offset = 1 + ady_dim1;
    ady -= ady_offset;
    ay_dim1 = *m;
    ay_offset = 1 + ay_dim1;
    ay -= ay_offset;

    /* Function Body */
    hi = (*xe - *xi) / (double) deltr_1.ni;
    x = *xi;
    i__1 = deltr_1.ni;
    for (j = 1; j <= i__1; ++j) {
	x += hi;

/* ------CALCULATION OF SOLUTION YI AT POINT X (BY ALGORITHM CLENSHAW) */

	de70dc_c(m, kp1, &x, &ay[ay_offset], yi, bk);

/* Computing 2nd power */
	d__1 = yi[0] - 1.;
/* Computing 2nd power */
	d__2 = yi[1] - 1.;
	deltr_1.r__[j + (*s << 4) - 17] = sqrt(d__1 * d__1 + d__2 * d__2);
	deltr_1.deltr[j + (*s << 4) - 17] = 1. - deltr_1.r__[j + (*s << 4) -
		17];
/* L10: */
    }
    return 0;
} /* ftreat_c */
